// (C) SLESH 2009
// http://slesh.name/
//
#pragma optimize("gsy",on) 
#pragma comment(linker,"/NODEFAULTLIB")
#pragma comment(linker,"/ENTRY:DllMain")
#pragma comment(linker,"/SUBSYSTEM:windows") 
#pragma comment(linker, "/MERGE:.data=.text")
#pragma comment(linker, "/MERGE:.rdata=.text")
#pragma comment(linker, "/SECTION:.text,EWR")


#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>


#include "IcqMod.h"

#pragma comment(lib, "ws2_32.lib")


void * __cdecl my_memcpy (
        void * dst,
        const void * src,
        size_t count
        )
{
        void * ret = dst;

        while (count--) {
                *(char *)dst = *(char *)src;
                dst = (char *)dst + 1;
                src = (char *)src + 1;
        }

        return(ret);
}


ULONG Host2Ip(char * host)
{
	struct hostent * p;
	ULONG ret;
	p = gethostbyname(host);
	if (p)
	{
		ret = *(ULONG*)(p->h_addr);
	}
	else
	{
		ret = INADDR_NONE;
	}

	return ret;
}

ULONG my_rand()
{
	_asm
	{
		rdtsc
	}
}



void XorPass(char * buf, int len)
{
	unsigned char key[]={0xF3, 0x26, 0x81, 0xC4, 0x39, 0x86, 0xDB, 0x92, 0x71, 0xA3, 0xB9, 0xE6, 0x53, 0x7A, 0x95, 0x7c};
    int i;

	for (i = 0; i < len; i++)
	{
		buf[i] = key[i] ^ buf[i];
    }
}


ULONG GetTVL(char * buf, int buflen, USHORT type, char * data,  int* len)
{
	ULONG ret = 0;

	type = HTONS(type);
	while (buflen)
	{
		if (*(USHORT*)buf == type)
		{
			*len = HTONS(*(USHORT*)(buf+2));
			my_memcpy(data, buf+4, *len);
			ret = 1;
			break;
		}
		else
		{
			buflen -= (4 + HTONS(*(USHORT*)(buf+2)));
			buf += (4 + HTONS(*(USHORT*)(buf+2)));
		}
	}

	return ret;
}



ULONG ConnectToServer(char * host, USHORT port, PPROXY_INFO proxy)
{
	S4_REQ s4;
	S5_METHOD_REQ s5mr;
	S5_REQ s5r;

	struct sockaddr_in addr;
	ULONG ip;
	ULONG sock = INVALID_SOCKET;
	
	ip = Host2Ip(host);
	if (ip != INADDR_NONE)
	{
		if (proxy)
		{
			addr.sin_addr.S_un.S_addr = proxy->ProxyIp;
			addr.sin_port = HTONS(proxy->ProxyPort);
		}
		else
		{
			addr.sin_addr.S_un.S_addr = ip;
			addr.sin_port = HTONS(port);
		}

		if (addr.sin_addr.S_un.S_addr != INADDR_NONE)
		{
			addr.sin_family = AF_INET;
			sock = socket(AF_INET, SOCK_STREAM, 0);

			if (sock != INVALID_SOCKET)
			{
				if (connect(sock, (struct sockaddr *)&addr, sizeof(addr)))
				{
					closesocket(sock);
					sock = INVALID_SOCKET;
				}
				else if (proxy)
				{
					switch (proxy->ProxyType)
					{
						case PROXY_TYPE_SOCKS_4:
							s4.command = 1;
							s4.addr = ip;
							s4.port = HTONS(port);
							s4.version = 4;

							send(sock, (char*)&s4, sizeof(S4_REQ), 0);
							if (recv(sock, (char*)&s4, sizeof(S4_REQ), 0) != sizeof(S4_REQ) || s4.command != 91)
							{
								closesocket(sock);
								sock = INVALID_SOCKET;
							}
							break;
						case PROXY_TYPE_SOCKS_5:
							s5mr.version = 5;
							s5mr.nmethods = 1;
							s5mr.methods = 0;

							send(sock, (char*)&s5mr, sizeof(S5_METHOD_REQ), 0);

							if (recv(sock, (char*)&s5mr, 2, 0) != 2 || s5mr.nmethods)
							{
								closesocket(sock);
								sock = INVALID_SOCKET;
							}
							else
							{
								s5r.version = 5;
								s5r.atype = 1;
								s5r.command = 1;
								s5r.ADDR_TYPE.ADDR_IP.port = HTONS(port);
								s5r.ADDR_TYPE.ADDR_IP.addr = ip;

								send(sock, (char*)&s5r, 10, 0);

								if (recv(sock, (char*)&s5r, 10, 0) != 10 || s5r.command)
								{
									closesocket(sock);
									sock = INVALID_SOCKET;
								}
							}
							break;
					}
				}
			}
		}
	}

	return sock;

}


ULONG GetFLAP(ULONG sock, PRAWPKT Pkt, ULONG timeout)
{
	ULONG ret = 0;
	int RecvLen;
	SINGLE_FD_SET sfd_set;
	TIMEVAL tv;

	sfd_set.fd_count = 1;
	sfd_set.fd_sock = sock;
	tv.tv_usec = 0;
	tv.tv_sec = timeout;

	if (select(0, (fd_set *)&sfd_set, 0, 0, &tv) == 1)
	{
		if (recv(sock, Pkt->Data, sizeof(ICQ_HEADER), 0) == sizeof(ICQ_HEADER))
		{
			RecvLen = HTONS(((PICQ_HEADER)Pkt->Data)->datalen);
			if (recv(sock, Pkt->Data, RecvLen, 0) == RecvLen)
			{
				Pkt->Len = RecvLen;
				ret = 1;
			}
		}

		if (!ret)
		{
			closesocket(sock);
		}
	}
	else
	{
		ret = 0xFFFFFFFF;
	}
	
	return ret;
}


void PktMemCpy(void* desc, void* src, int len)
{
	my_memcpy(desc, src, len);
}

void PktInt(PRAWPKT Pkt, ULONG val, int len)
{
	PktMemCpy(Pkt->Data + Pkt->Len, &val, len);
	Pkt->Len += len;
}

void PktStr(PRAWPKT Pkt, char* str, int len)
{
	PktMemCpy(Pkt->Data + Pkt->Len, str, len);
	Pkt->Len += len;
}

void PktInit(PRAWPKT Pkt, BYTE Channel, USHORT Seq)
{
	Pkt->Len = 0;
	PktInt(Pkt, 0x2A, 1);
	PktInt(Pkt, Channel, 1);
	PktInt(Pkt, HTONS(Seq), 2);
	PktInt(Pkt, 0, 2);
}

void PktSnac(PRAWPKT Pkt, USHORT Family, USHORT SubType, ULONG ID, USHORT Flags)
{
	PktInt(Pkt, HTONS(Family), 2);
	PktInt(Pkt, HTONS(SubType), 2);
	PktInt(Pkt, HTONS(Flags), 2);
	PktInt(Pkt, HTOHL(ID), 4);
}


void PktTVL(PRAWPKT Pkt, USHORT type, USHORT len)
{
	PktInt(Pkt, type, 2);
	PktInt(Pkt, len, 2);
}

void PktFinish(PRAWPKT Pkt)
{
	*(USHORT*)(Pkt->Data + 4) = HTONS(Pkt->Len - 6);
}


void BuildQuery_SendMsg(RAWPKT* Pkt, USHORT seq, char * UIN, char * msg)
{
	int len;
	RAWPKT lpkt;
	RAWPKT pmsg;

	PktInit(Pkt, 2, seq);
	PktSnac(Pkt, 4, 6, 0, 0);
	PktInt(Pkt, 0, 4);
	PktInt(Pkt, HTOHL(my_rand() % 0xFFFFAA), 4);
	PktInt(Pkt, HTONS(1), 2);
	
	len = strlen(UIN);
	PktInt(Pkt, len, 1);
	PktStr(Pkt, UIN, len);
	
	lpkt.Len = 0;
	
	PktTVL(&lpkt, HTONS(1281), HTONS(1));
	PktInt(&lpkt, 1, 1);

	pmsg.Len = 0;
	PktInt(&pmsg, 0, 4);
	PktStr(&pmsg, msg, strlen(msg));
	
	PktTVL(&lpkt, HTONS(257), HTONS(pmsg.Len));

	PktStr(&lpkt, pmsg.Data, pmsg.Len);
	
	PktTVL(Pkt, HTONS(2), HTONS(lpkt.Len));

	PktStr(Pkt, lpkt.Data, lpkt.Len);
	
	PktTVL(Pkt, HTONS(6), 0);
	
	PktFinish(Pkt);
}


void BuildQuery_SendAuth(RAWPKT* Pkt, USHORT seq, char * UIN, char * msg)
{
	int len;

	PktInit(Pkt, 2, seq);
	PktSnac(Pkt, 0x13, 0x18, 0x18, 0);

	len = strlen(UIN);
	PktInt(Pkt, len, 1);
	PktStr(Pkt, UIN, len);

	len = strlen(msg);
	if (!len)
	{
		PktInt(Pkt, 0, 2);
	}
	else
	{
		PktInt(Pkt, HTONS(len), 2);
		PktStr(Pkt, msg, len);
	}

	PktInt(Pkt, 0, 2);
	PktFinish(Pkt);
}

void BuildQuery_Auth(RAWPKT* Pkt, USHORT seq, char * login, char * pass)
{
	int len;

	PktInit(Pkt, 1, seq);
	PktInt(Pkt, HTOHL(1), 4);
	
	PktInt(Pkt, HTONS(ICQ_DATA_TYPE_UIN), 2);
	len = strlen(login);
	PktInt(Pkt, HTONS(len), 2);
	PktStr(Pkt, login, len);

	PktInt(Pkt, HTONS(ICQ_DATA_TYPE_DATA), 2);
	len = strlen(pass);
	PktInt(Pkt, HTONS(len), 2);
	PktStr(Pkt, pass, len);
	XorPass(Pkt->Data + Pkt->Len - len, len);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLIENT), HTONS(8));
	PktInt(Pkt, HTOHL('ICQB'), 4);
	PktInt(Pkt, HTOHL('asic'), 4);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLIENT_ID), HTONS(2));
	PktInt(Pkt, HTONS(266), 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLI_MAJOR_VER), HTONS(2));
	PktInt(Pkt, HTONS(20), 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLI_MINOR_VER), HTONS(2));
	PktInt(Pkt, HTONS(34), 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLI_LESSER_VER), HTONS(2));
	PktInt(Pkt, 0, 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLI_BUILD_NUMBER), HTONS(2));
	PktInt(Pkt, HTONS(2321), 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_DISTRIB_NUMBER), HTONS(4));
	PktInt(Pkt, HTOHL(1085), 4);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLIENT_LNG), HTONS(2));
	PktInt(Pkt, 'ne', 2);

	PktTVL(Pkt, HTONS(ICQ_DATA_TYPE_CLIENT_COUNTRY), HTONS(2));
	PktInt(Pkt, 'su', 2);

	PktFinish(Pkt);
}

ULONG _stdcall ICQSendMsg(PICQ_CLIENT client, char * UIN, char * msg)
{
	ULONG ret = 0;
	RAWPKT Pkt;
	
	if (client->status == ICQ_CLIENT_STATUS_CONNECTED)
	{
		BuildQuery_SendMsg(&Pkt, client->sequence++, UIN, msg);	

		if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
		{
			client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
			closesocket(client->sock);
		}
		else
		{
			ret = 1;
		}
	}

	return ret;
}

ULONG _stdcall ICQSendAuth(PICQ_CLIENT client, char * UIN, char * msg)
{
	ULONG ret = 0;
	RAWPKT Pkt;
	
	if (client->status == ICQ_CLIENT_STATUS_CONNECTED)
	{
		BuildQuery_SendAuth(&Pkt, client->sequence++, UIN, msg);	

		if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
		{
			client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
			closesocket(client->sock);
		}
		else
		{
			ret = 1;
		}
	}

	return ret;
}


ULONG _stdcall ICQAuth(PICQ_CLIENT client, char * UIN, ULONG AuthOk)
{
	ULONG ret = 0;
	RAWPKT Pkt;
	int len;
	
	if (client->status == ICQ_CLIENT_STATUS_CONNECTED)
	{
		PktInit(&Pkt, 2, client->sequence++);
		PktSnac(&Pkt, 0x13, 0x1A, 0x1A, 0);
		len = strlen(UIN);
		PktInt(&Pkt, len, 1);
		PktStr(&Pkt, UIN, len);

		PktInt(&Pkt, AuthOk, 1);
		PktTVL(&Pkt, 0, 0);
		PktFinish(&Pkt);

		if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
		{
			client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
			closesocket(client->sock);
		}
		else
		{
			ret = 1;
		}
	}

	return ret;
}




ULONG _stdcall ICQConnect(PICQ_CLIENT client, char * host, USHORT port, char * login, char * pass, PROXY_INFO* proxy)
{
	ULONG ret;
	RAWPKT Pkt;
	int len;
	char * tmp;
	int ServerLen;
	char Cookie[512];
	char NewServer[64];
	
	
	client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
	client->sequence = (USHORT)my_rand();
	
	client->sock = ConnectToServer(host, port, proxy);
	if (client->sock == INVALID_SOCKET)
	{
		ret = ICQ_CONNECT_STATUS_CONNECT_ERROR;
	}
	else if (GetFLAP(client->sock, &Pkt, 20000) != 1)
	{
		ret = ICQ_CONNECT_STATUS_RECV_ERROR;
	}
	else
	{
		
		BuildQuery_Auth(&Pkt, client->sequence++, login, pass);

		if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
		{
			ret = ICQ_CONNECT_STATUS_SEND_ERROR;
		}
		else if (GetFLAP(client->sock, &Pkt, 20000) != 1)
		{
			ret = ICQ_CONNECT_STATUS_RECV_ERROR;
		}
		else if (!GetTVL(Pkt.Data, Pkt.Len, ICQ_DATA_TYPE_RECONECT_HERE, NewServer, &ServerLen) ||
				 !GetTVL(Pkt.Data, Pkt.Len, ICQ_DATA_TYPE_COOKIE, Cookie, &len))
		{
			ret = ICQ_CONNECT_STATUS_AUTH_ERROR;
		}
		else
		{
			PktInit(&Pkt, 4, client->sequence++);
			PktInt(&Pkt, 0x30, 1);
			PktFinish(&Pkt);
	
			send(client->sock, Pkt.Data, Pkt.Len, 0);
			closesocket(client->sock);

			NewServer[ServerLen] = 0x00;
			tmp = NewServer;

			while (tmp[0])
			{
				if (tmp[0] == ':')
				{
					tmp[0] = 0x00;
					break;
				}
				tmp++;
			}

			client->sock = ConnectToServer(NewServer, port, proxy);
			if (client->sock == INVALID_SOCKET)
			{
				ret = ICQ_CONNECT_STATUS_CONNECT_ERROR;
			}
			else if (GetFLAP(client->sock, &Pkt, 20000) != 1)
			{
				ret = ICQ_CONNECT_STATUS_RECV_ERROR;
			}
			else
			{
				PktInit(&Pkt, 1, client->sequence++);
				PktInt(&Pkt, HTOHL(1), 4); 
				
				PktTVL(&Pkt, HTONS(ICQ_DATA_TYPE_COOKIE), HTONS(len));
				PktStr(&Pkt, Cookie, len);
				PktFinish(&Pkt);

				if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
				{
					ret = ICQ_CONNECT_STATUS_SEND_ERROR;
				}
				else if (GetFLAP(client->sock, &Pkt, 20000) != 1)
				{
					ret = ICQ_CONNECT_STATUS_RECV_ERROR;
				}
				else
				{
					PktInit(&Pkt, 2, client->sequence++);
					PktTVL(&Pkt, HTONS(1), HTONS(2));
					PktInt(&Pkt, 0, 2);
					PktInt(&Pkt, HTOHL(1), 4);
					PktStr(&Pkt, (char*)SNAC0102, 64);
					PktFinish(&Pkt);
	
					if (send(client->sock, Pkt.Data, Pkt.Len, 0) != Pkt.Len)
					{
						ret = ICQ_CONNECT_STATUS_SEND_ERROR;
					}
					else
					{
						client->status = ICQ_CLIENT_STATUS_CONNECTED;
						ret = ICQ_CONNECT_STATUS_OK;
					}
				}
			}
		} 
	}

	if (ret != ICQ_CONNECT_STATUS_OK &&
		client->sock != INVALID_SOCKET)
	{
		closesocket(client->sock);
	}
	  
	
	return ret;
} 

 void  _stdcall ICQClose(PICQ_CLIENT client)
{
	if (client->status == ICQ_CLIENT_STATUS_CONNECTED)
	{
		closesocket(client->sock);
		client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
	}
}


 
void Utf8ToAnsi(char * msg, char * from, int len)
{
	WideCharToMultiByte(CP_ACP, 0, (LPWSTR)from, -1, msg, 8192, 0, 0);
	len = len >> 1;
	msg[len] = 0x00;
}


void ReverseWord(char * msg, int len)
{
	int x;
	BYTE b;

	for (x = 0; x < len; x+=2)
	{
		b = msg[x];
		msg[x] = msg[x+1];
		msg[x+1] = b;
	}
}

ULONG _stdcall ICQReadMsg(PICQ_CLIENT client, char* UIN, char* msg, int* msglen)
{
	ULONG ret = 0;
	PICQ_MSG_HEADER MsgHdr;
	RAWPKT Pkt;
	USHORT TVL;
	char * data;
	int x;
	int len;

	if (client->status == ICQ_CLIENT_STATUS_CONNECTED)
	{
		x = GetFLAP(client->sock, &Pkt, 0);
		if (x == 1)
		{
			MsgHdr = (PICQ_MSG_HEADER)Pkt.Data;
		
			if (MsgHdr->family == HTONS(4) && MsgHdr->subtype == HTONS(7) && MsgHdr->channel == HTONS(1))
			{
				msg[0] = 0x00;
				data = Pkt.Data + sizeof(ICQ_MSG_HEADER);
				my_memcpy(UIN, data, MsgHdr->namesize);
				UIN[MsgHdr->namesize] = 0x00;

				data += MsgHdr->namesize;
				TVL = HTONS(*(USHORT*)(data + 2));
				data += 4;
				if (TVL)
				{
					for (x = 0; x <= TVL; x++)
					{
						if (*(USHORT*)data == HTONS(2))
						{
							TVL = HTONS(*(USHORT*)(data + 2));
							data += 4;
							while (TVL)
							{
								len = HTONS(*(USHORT*)(data + 2));
								if (data[0] == 1 && data[1] == 1) // id = 1  ver = 1
								{
									len -= 4;
									
									if (HTONS(*(USHORT*)(data + 4)) == 0002)
									{
										ReverseWord(data+8, len);
										Utf8ToAnsi(msg, data+8, len);										
									}
									else
									{
										my_memcpy(msg, data+8, len);
										msg[len] = 0x00;
									}

									if (msglen)
									{
										*msglen = len >> 1;
									}
									ret = 1;
									break;
								}
								else
								{
									data += (len + 4);
									TVL -= (len + 4);
								}
							}
							break;
						}
						else
						{
							data += (4 + HTONS(*(USHORT*)(data + 2)));
						}
					}
				}
			}
		}
		else if (!x)
		{
			client->status = ICQ_CLIENT_STATUS_DISCONNECTED;
		}
	}
	
	return ret;
}

BOOL __stdcall DllMain(HMODULE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{	
	WSADATA ws;
	static char CopyRight[] = "(C) SLESH 2009";

	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH: 
			WSAStartup(0x202, &ws);			
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
	return 1;
}


